BUTTON_A      = 1 << 7
BUTTON_B      = 1 << 6
BUTTON_SELECT = 1 << 5
BUTTON_START  = 1 << 4
BUTTON_UP     = 1 << 3
BUTTON_DOWN   = 1 << 2
BUTTON_LEFT   = 1 << 1
BUTTON_RIGHT  = 1 << 0

ReadPad:
	; At the same time that we strobe bit 0, we initialize the ring counter
	; so we're hitting two birds with one stone here
	lda #$01
    ; While the strobe bit is set, buttons will be continuously reloaded.
    ; This means that reading from JOY1 will only return the state of the
    ; first button: button A.
	sta JOY1
	sta pad1
	lsr a 			; now A is 0
    ; By storing 0 into JOY1, the strobe bit is cleared and the reloading stops.
    ; This allows all 8 buttons (newly reloaded) to be read from JOY1.
	sta JOY1
JoyReadLoop:
	lda JOY1
	lsr a	       	; bit 0 -> Carry
	rol pad1		; Carry -> bit 0; bit 7 -> Carry
	bcc JoyReadLoop
	rts